import S from 'jsonschema-definer'

export const sTypeLevel = S.string().enum('character', 'vocabulary')
export const sType = S.anyOf(sTypeLevel, S.string().enum('sentence'))

export const sLevelBrowserByType = S.shape({
  whatToShow: S.list(S.string()),
})

const oLevelBrowser: Record<
  typeof sTypeLevel.type,
  typeof sLevelBrowserByType
> = {
  character: sLevelBrowserByType,
  vocabulary: sLevelBrowserByType,
}

export const sLevelBrowser = S.shape(oLevelBrowser)

const oUserLocalSettings = {
  level: S.integer(),
  levelMin: S.integer().optional(),
  level_browser: sLevelBrowser.optional(),
}

const oUserSettings = {
  ...oUserLocalSettings,
  identifier: S.string(),
}

export const sUserLocalSettings = S.shape(oUserLocalSettings)
export const sUserSettings = S.shape(oUserSettings)
